<?php
/*
* @version      1.5.8
* @author       BPC
* @package      Jshopping
*/
defined('_JEXEC') or die('Restricted access');
require_once(__DIR__ . '/include.php');
if (!class_exists('DiscountHelper')) {
require_once(__DIR__ . '/DiscountHelper.php');
}

class pm_bpc extends PaymentRoot
{
const VERSION = '1.5.8';
const ORDER_APPROVED = 'approved';
const ORDER_DECLINED = 'declined';
const SIGNATURE_SEPARATOR = '|';
const ORDER_SEPARATOR = ":";
public $allowCallbacks = BPC_ENABLE_CALLBACK; //temporarily disabled globally
public $cacert_path = null;
function showPaymentForm($params, $pmconfigs)
{
include(dirname(__FILE__) . "/paymentform.php");
}
function showAdminFormParams($params)
{
$module_params_array = array(
'bpc_merchant_token',
'bpc_merchant_login',
'bpc_merchant_password',
'bpc_test_mode',
'bpc_two_stage',
'bpc_send_cart_data',
'bpc_taxSystem',
'transaction_end_status',
'transaction_failed_status',
);
foreach ($module_params_array as $module_param) {
if (!isset($params[$module_param]))
$params[$module_param] = '';
}
$this->_loadLanguageFile();
$bpc_taxSystems = array();
$bpc_taxSystems[] = JHTML::_('select.option', 0, _JSHOP_BPC_ENTRY_TAX_SYSTEM_1, 'id', 'name');
$bpc_taxSystems[] = JHTML::_('select.option', 1, _JSHOP_BPC_ENTRY_TAX_SYSTEM_2, 'id', 'name');
$bpc_taxSystems[] = JHTML::_('select.option', 2, _JSHOP_BPC_ENTRY_TAX_SYSTEM_3, 'id', 'name');
$bpc_taxSystems[] = JHTML::_('select.option', 3, _JSHOP_BPC_ENTRY_TAX_SYSTEM_4, 'id', 'name');
$bpc_taxSystems[] = JHTML::_('select.option', 4, _JSHOP_BPC_ENTRY_TAX_SYSTEM_5, 'id', 'name');
$bpc_taxSystems[] = JHTML::_('select.option', 5, _JSHOP_BPC_ENTRY_TAX_SYSTEM_6, 'id', 'name');
$bpc_ffdVersions = array();
$bpc_ffdVersions[] = JHTML::_('select.option', 'v1_05', 'v1.05', 'id', 'name');
$bpc_ffdVersions[] = JHTML::_('select.option', 'v1_2', 'v1.2', 'id', 'name');
$bpc_paymentMethodTypeList = array();
$bpc_paymentMethodTypeList[] = JHTML::_('select.option', '1', _JSHOP_BPC_ENTRY_PAYMENT_METHOD_1, 'id', 'name');
$bpc_paymentMethodTypeList[] = JHTML::_('select.option', '2', _JSHOP_BPC_ENTRY_PAYMENT_METHOD_2, 'id', 'name');
$bpc_paymentMethodTypeList[] = JHTML::_('select.option', '3', _JSHOP_BPC_ENTRY_PAYMENT_METHOD_3, 'id', 'name');
$bpc_paymentMethodTypeList[] = JHTML::_('select.option', '4', _JSHOP_BPC_ENTRY_PAYMENT_METHOD_4, 'id', 'name');
$bpc_paymentMethodTypeList[] = JHTML::_('select.option', '5', _JSHOP_BPC_ENTRY_PAYMENT_METHOD_5, 'id', 'name');
$bpc_paymentMethodTypeList[] = JHTML::_('select.option', '6', _JSHOP_BPC_ENTRY_PAYMENT_METHOD_6, 'id', 'name');
$bpc_paymentMethodTypeList[] = JHTML::_('select.option', '7', _JSHOP_BPC_ENTRY_PAYMENT_METHOD_7, 'id', 'name');
$bpc_paymentObjectTypeList = array();
$bpc_paymentObjectTypeList[] = JHTML::_('select.option', '1', _JSHOP_BPC_ENTRY_PAYMENT_OBJECT_1, 'id', 'name');
$bpc_paymentObjectTypeList[] = JHTML::_('select.option', '2', _JSHOP_BPC_ENTRY_PAYMENT_OBJECT_2, 'id', 'name');
$bpc_paymentObjectTypeList[] = JHTML::_('select.option', '3', _JSHOP_BPC_ENTRY_PAYMENT_OBJECT_3, 'id', 'name');
$bpc_paymentObjectTypeList[] = JHTML::_('select.option', '4', _JSHOP_BPC_ENTRY_PAYMENT_OBJECT_4, 'id', 'name');
$bpc_paymentObjectTypeList[] = JHTML::_('select.option', '5', _JSHOP_BPC_ENTRY_PAYMENT_OBJECT_5, 'id', 'name');
$bpc_paymentObjectTypeList[] = JHTML::_('select.option', '7', _JSHOP_BPC_ENTRY_PAYMENT_OBJECT_7, 'id', 'name');
$bpc_paymentObjectTypeList[] = JHTML::_('select.option', '9', _JSHOP_BPC_ENTRY_PAYMENT_OBJECT_9, 'id', 'name');
$bpc_paymentObjectTypeList[] = JHTML::_('select.option', '10', _JSHOP_BPC_ENTRY_PAYMENT_OBJECT_10, 'id', 'name');
$bpc_paymentObjectTypeList[] = JHTML::_('select.option', '12', _JSHOP_BPC_ENTRY_PAYMENT_OBJECT_12, 'id', 'name');
$bpc_paymentObjectTypeList[] = JHTML::_('select.option', '13', _JSHOP_BPC_ENTRY_PAYMENT_OBJECT_13, 'id', 'name');

$orders = JModelLegacy::getInstance('orders', 'JshoppingModel');
include dirname(__FILE__) . '/adminparamsform.php';
}
function showEndForm($pmconfig, $order)
{
$lang = \JFactory::getLanguage()->getTag();
$language = substr($lang, 0, 2);
$order_id = $order->order_id;
$description = 'Order :' . $order_id;
$base_url = JURI::root() . 'index.php?option=com_jshopping&controller=checkout&task=step7&js_paymentclass=' . __CLASS__ . '&order_id=' . $order_id;
$return_url = $base_url . '&bpc=result&act=finish';
$callback_url = $base_url . '&bpc=callback&act=finish';
$fail_url = $base_url . '&act=cancel';
$amount = round($this->_fixOrderTotal($order) * 100);
$jsonParams_array = array(
'CMS:' => 'Joomla + Jshopping ',
'Module-Version: ' => self::VERSION,
);
if (defined('BPC_ENABLE_BACK_URL_SETTINGS')
&& BPC_ENABLE_BACK_URL_SETTINGS === true
&& !empty($pmconfig['bpc_back_url'])
) {
$jsonParams_array['backToShopUrl'] = $pmconfig['bpc_back_url'];
}
$args = array(
'orderNumber' => $order_id . self::ORDER_SEPARATOR . time(),
'amount' => $amount,
'returnUrl' => $return_url,
'dynamicCallbackUrl' => $callback_url . "&CALLBACK_TYPE=DYNAMIC",
'failUrl' => $fail_url,
'language' => $language,
'jsonParams' => json_encode($jsonParams_array),
);
if (defined('BPC_MANDATORY_CURRENCY') && BPC_MANDATORY_CURRENCY === true) {
$numeric_code = $this->_get_numeric_currency_code($order->currency_code_iso);
if ($numeric_code !== null) {
$args['currency'] = $numeric_code;
}
}
if (defined('BPC_SEND_CLIENT_FULL_INFO') && BPC_SEND_CLIENT_FULL_INFO === true) {
$billingPayerData = $this->_getBillingPayerData($order);
if(!empty($billingPayerData)) {
$args['billingPayerData'] = json_encode($billingPayerData);
}
}
if (!empty($pmconfig['bpc_merchant_token'])) {
$decoded_credentials = base64_decode($pmconfig['bpc_merchant_token']);
list($l, $p) = explode(':', $decoded_credentials);
$args['userName'] = $l;
$args['password'] = $p;
} else {
$args['userName'] = $pmconfig['bpc_merchant_login'];
$args['password'] = $pmconfig['bpc_merchant_password'];
}

if (!empty($order->user_id && $order->user_id > 0)) {
$client_email = !empty($order->email) ? $order->email : "";
$args['clientId'] = md5($order->user_id . $client_email . JURI::root());
}
if ($pmconfig['bpc_test_mode'] == 1) {
$action_adr = BPC_TEST_URL;
} else {
$action_adr = BPC_PROD_URL;
if (defined('BPC_PROD_URL_ALTERNATIVE_DOMAIN') && defined('BPC_PROD_URL_ALT_PREFIX')) {
if (substr($pmconfig['bpc_merchant_login'], 0, strlen(BPC_PROD_URL_ALT_PREFIX)) == BPC_PROD_URL_ALT_PREFIX) {
$pattern = '/^https:\/\/[^\/]+/';
$action_adr = preg_replace($pattern, rtrim(BPC_PROD_URL_ALTERNATIVE_DOMAIN, '/'), $action_adr);
} else {
$this->allowCallbacks = false;
}
}
}
if ($this->allowCallbacks === true) {
if (!empty($pmconfig['bpc_merchant_token'])) {
$decoded_credentials = base64_decode($pmconfig['bpc_merchant_token']);
list($l, $p) = explode(':', $decoded_credentials);
$login = $l;
$password = $p;
} else {
$login = $pmconfig['bpc_merchant_login'];
$password = $pmconfig['bpc_merchant_password'];
}
if ($pmconfig['bpc_test_mode'] == 1) {
$gate_url = str_replace("payment/rest", "mportal/mvc/public/merchant/update", $action_adr);
if (defined('BPC_TEST_URL_ALTERNATIVE_DOMAIN')) {
$pattern = '/^https:\/\/[^\/]+/';
$gate_url = preg_replace($pattern, rtrim(BPC_TEST_URL_ALTERNATIVE_DOMAIN, '/'), $gate_url);
}
} else {
$gate_url = str_replace("payment/rest", "mportal/mvc/public/merchant/update", $action_adr);
if (defined('BPC_PROD_URL_ALTERNATIVE_DOMAIN')) {
$pattern = '/^https:\/\/[^\/]+/';
$gate_url = preg_replace($pattern, rtrim(BPC_PROD_URL_ALTERNATIVE_DOMAIN, '/'), $gate_url);
}
}
$gate_url .= substr($login, 0, -4); // we guess username = login w/o "-api"
$headers = array(
'Content-Type:application/json',
'Authorization: Basic ' . base64_encode($login . ":" . $password)
);
$data['callbacks_enabled'] = true;
$data['callback_type'] = "DYNAMIC";
$data['callback_http_method'] = "GET";
$data['callback_operations'] = "deposited,approved,declinedByTimeout";
$response = $this->_sendGatewayData(json_encode($data), $gate_url, $headers, $this->cacert_path);
$this->_writeLog($response);
}
if ($pmconfig['bpc_two_stage'] == 0) {
$action_adr .= 'register.do';
} else {
$action_adr .= 'registerPreAuth.do';
}
if ($pmconfig['bpc_send_cart_data'] == 1) {
$args['taxSystem'] = $pmconfig['bpc_taxSystem'];
$order_items = $order->getAllItems();
$itemsCnt = 1;
$orderBundle = [];
$orderBundle['customerDetails'] = array(
'email' => $order->email
);
foreach ($order_items as $value) {
$item = array();
$item_tax = $value->product_tax;
$taxType = $this->_getTaxType($item_tax);
$product_price = ceil($value->product_item_price * 100);
$item['positionId'] = $itemsCnt++;
$item['name'] = $value->product_name;
if ($pmconfig['bpc_version'] == "v1_05") {
$item['quantity'] = array(
'value' => $value->product_quantity,
'measure' => BPC_MEASUREMENT_NAME
);
}
if ($pmconfig['bpc_version'] == "v1_2") {
$item['quantity'] = array(
'value' => $value->product_quantity,
'measure' => BPC_MEASUREMENT_CODE
);
}
$item['itemAmount'] = $product_price * $value->product_quantity;
$item['itemCode'] = $value->product_id;
$item['tax'] = array(
'taxType' => $taxType
);
$item['itemPrice'] = $product_price;
$attributes = array();
$attributes[] = array(
"name" => "paymentMethod",
"value" => $pmconfig['bpc_paymentMethodType']
);
$attributes[] = array(
"name" => "paymentObject",
"value" => $pmconfig['bpc_paymentObjectType']
);
$item['itemAttributes']['attributes'] = $attributes;
$orderBundle['cartItems']['items'][] = $item;
}
if ($order->order_shipping > 0) {
$amount -= ceil($order->order_shipping * 100);
}
$discountHelper = new DiscountHelper();
$discount = $discountHelper->discoverDiscount($amount, $orderBundle['cartItems']['items']);
if ($discount > 0) {
$discountHelper->setOrderDiscount($discount);
$recalculatedPositions = $discountHelper->normalizeItems($orderBundle['cartItems']['items']);
$orderBundle['cartItems']['items'] = $recalculatedPositions;
}
if ($order->order_shipping > 0) {
$itemShipment['positionId'] = $itemsCnt;
$itemShipment['name'] = _JSHOP_BPC_PAYMENT_DELIVERY;
if ($pmconfig['bpc_version'] == "v1_05") {
$itemShipment['quantity'] = array(
'value' => 1,
'measure' => BPC_MEASUREMENT_NAME
);
}
if ($pmconfig['bpc_version'] == "v1_2") {
$itemShipment['quantity'] = array(
'value' => 1,
'measure' => BPC_MEASUREMENT_CODE
);
}
$itemShipment['itemAmount'] = $itemShipment['itemPrice'] = ceil($order->order_shipping * 100);
$itemShipment['itemCode'] = 'Delivery';
$attributes = array();
$attributes[] = array(
"name" => "paymentMethod",
"value" => $pmconfig['bpc_paymentMethodType']
);
$attributes[] = array(
"name" => "paymentObject",
"value" => 4
);
$itemShipment['itemAttributes']['attributes'] = $attributes;
$orderBundle['cartItems']['items'][] = $itemShipment;
}
$args['orderBundle'] = json_encode($orderBundle);
}

if (file_exists(dirname(__FILE__) . "/cacert.cer") && $pmconfig['bpc_enable_cacert'] == 1) {
$this->cacert_path = dirname(__FILE__) . "/cacert.cer";
}
$response = $this->_sendGatewayData(http_build_query($args, '', '&'), $action_adr, array(), $this->cacert_path);
$this->_writeLog("[REQUEST]: " . $action_adr . ": \nDATA: " . print_r($args, true) . "\n[RESPONSE]: " . $response);
$response = json_decode($response, true);
if (!empty($response['formUrl'])) {
header("Location: " . $response['formUrl']);
exit;
} else {
$message = "ERROR #" . $response['errorCode'] . ": " . $response['errorMessage'];
\JFactory::getApplication()->enqueueMessage($message, 'error');
return array(0, $message);
}
}
function checkTransaction($pm_config, $order, $rescode)
{
$this->_loadLanguageFile();
$payment_data = \JFactory::getApplication()->input->get->getArray();
if ($pm_config['bpc_test_mode'] == 1) {
$action_adr = BPC_TEST_URL;
} else {
$action_adr = BPC_PROD_URL;
if (defined('BPC_PROD_URL_ALTERNATIVE_DOMAIN') && defined('BPC_PROD_URL_ALT_PREFIX')) {
if (substr($pm_config['bpc_merchant_login'], 0, strlen(BPC_PROD_URL_ALT_PREFIX)) == BPC_PROD_URL_ALT_PREFIX) {
$pattern = '/^https:\/\/[^\/]+/';
$action_adr = preg_replace($pattern, rtrim(BPC_PROD_URL_ALTERNATIVE_DOMAIN, '/'), $action_adr);
}
}
}
$action_adr .= 'getOrderStatusExtended.do';
if (!empty($pm_config['bpc_merchant_token'])) {
$decoded_credentials = base64_decode($pm_config['bpc_merchant_token']);
list($l, $p) = explode(':', $decoded_credentials);
$args['userName'] = $l;
$args['password'] = $p;
} else {
$args['userName'] = $pm_config['bpc_merchant_login'];
$args['password'] = $pm_config['bpc_merchant_password'];
}
if (isset($payment_data['bpc'])) {
$action = $payment_data['bpc'];
switch ($action) {
case "result":
$args['orderId'] = isset($payment_data['orderId']) ? $payment_data['orderId'] : null;
$response = $this->_sendGatewayData(http_build_query($args, '', '&'), $action_adr);
$this->_writeLog("[REQUEST RU]: " . $action_adr . ": \nDATA: " . print_r($args, true) . "\n[RESPONSE]: " . $response);
$response = json_decode($response, true);
$orderStatus = $response['orderStatus'];
if ($orderStatus == '1' || $orderStatus == '2') {
$message = _JSHOP_BPC_ENTRY_ORDER . " " . $payment_data['order_id'] . " " . _JSHOP_BPC_ENTRY_WAS_PAID;
\JFactory::getApplication()->enqueueMessage($message . " " . $_REQUEST['payment_id']);
return array(1, _JSHOP_BPC_ENTRY_WAS_PAID . ' ID:' . $_REQUEST['payment_id']);
} else {
$message = _JSHOP_BPC_ENTRY_PAYMENT_ERROR;
if ($this->allowCallbacks === false) {
\JFactory::getApplication()->enqueueMessage($message . " " . $_REQUEST['payment_id']);
return array(0, $message);
}
}
break;
case "callback":
$args['orderId'] = isset($payment_data['mdOrder']) ? $payment_data['mdOrder'] : null;
$response = $this->_sendGatewayData(http_build_query($args, '', '&'), $action_adr);
$this->_writeLog("[REQUEST CB]: " . $action_adr . ": \nDATA: " . print_r($args, true) . "\n[RESPONSE]: " . $response);
$response = json_decode($response, true);
$orderStatus = $response['orderStatus'];
if ($orderStatus == '1' || $orderStatus == '2') {
$message = _JSHOP_BPC_ENTRY_ORDER . " " . $payment_data['order_id'] . " " . _JSHOP_BPC_ENTRY_WAS_PAID;
\JFactory::getApplication()->enqueueMessage($message . " " . $_REQUEST['payment_id']);
return array(1, _JSHOP_BPC_ENTRY_WAS_PAID . ' ID:' . $_REQUEST['payment_id']);
} else {
return array(0, _JSHOP_BPC_ENTRY_PAYMENT_ERROR);
}
break;
}
}
}
function getUrlParams($bpc_config)
{
$params = array();
$params['order_id'] = \JFactory::getApplication()->input->getInt("order_id");
$params['hash'] = "";
$params['checkHash'] = 0;
$params['checkReturnParams'] = 1;
return $params;
}
public function _sendGatewayData($data, $action_address, $headers = array(), $ca_info = null)
{
$curl_opt = array(
CURLOPT_HTTPHEADER => $headers,
CURLOPT_VERBOSE => true,
CURLOPT_SSL_VERIFYHOST => false,
CURLOPT_URL => $action_address,
CURLOPT_RETURNTRANSFER => true,
CURLOPT_POST => true,
CURLOPT_POSTFIELDS => $data,
CURLOPT_HEADER => true,
);
$ssl_verify_peer = false;
if ($ca_info != null) {
$ssl_verify_peer = true;
$curl_opt[CURLOPT_CAINFO] = $ca_info;
}
$curl_opt[CURLOPT_SSL_VERIFYPEER] = $ssl_verify_peer;
$ch = curl_init();
curl_setopt_array($ch, $curl_opt);
$response = curl_exec($ch);
if ($response === false) {
$response['errorCode'] = 999;
$response['errorMessage'] = curl_error($ch);
return json_encode($response);
}
$header_size = curl_getinfo($ch, CURLINFO_HEADER_SIZE);
curl_close($ch);
return substr($response, $header_size);
}
function _writeLog($var, $info = true)
{
$information = "";
if ($var) {
if ($info) {
$information = "\n\n";
$information .= str_repeat("-=", 64);
$information .= "\nDate: " . date('Y-m-d H:i:s') . "\n";
}
$result = $var;
if (is_array($var) || is_object($var)) {
$result = "\n" . print_r($var, true);
}
$result .= "\n\n";
$path = dirname(__FILE__) . '/js_bpc_' . date('Y-m') . '.log';
error_log($information . $result, 3, $path);
return true;
}
return false;
}
function _fixOrderTotal($order)
{
$total = $order->order_total;
if ($order->currency_code_iso == 'HUF') {
$total = round($total);
} else {
$total = number_format($total, 2, '.', '');
}
return $total;
}
function _getTaxType($item_tax)
{
if ($item_tax == 20) {
$taxType = 6;
} else if ($item_tax == 18) {
$taxType = 3;
} else if ($item_tax == 10) {
$taxType = 2;
} else if ($item_tax == 0) {
$taxType = 1;
} else {
$taxType = 0;
}
return $taxType;
}
function _loadLanguageFile()
{
$lang = \JFactory::getLanguage();
$langtag = $lang->getTag();
if (file_exists(JPATH_ROOT . '/components/com_jshopping/payments/' . __CLASS__ . '/lang/' . $langtag . '.php')) {
require_once(JPATH_ROOT . '/components/com_jshopping/payments/' . __CLASS__ . '/lang/' . $langtag . '.php');
} else {
require_once(JPATH_ROOT . '/components/com_jshopping/payments/' . __CLASS__ . '/lang/en-GB.php');
}
}
function _getBillingPayerData($order) {
$billingPayerData = array();
$billingAddress1 = $order->street ?? '';
$billingAddress2 = $order->street_nr ?? '';
$billingCity = $order->city ?? '';
$billingPostcode = $order->zip ?? '';
$billingCountry = $order->country ?? '';
$billingState = $order->state ?? '';
if (!empty($billingCity)) {
$billingPayerData['billingCity'] = $billingCity;
}
if (!empty($billingCountry)) {
$billingPayerData['billingCountry'] = $billingCountry;
}
if (!empty($billingAddress1)) {
$billingPayerData['billingAddressLine1'] = $billingAddress1;
}
if (!empty($billingAddress2)) {
$billingPayerData['billingAddressLine2'] = $billingAddress2;
}
if (!empty($billingAddress3)) {
$billingPayerData['billingAddressLine3'] = $billingAddress3;
}
if (!empty($billingPostcode)) {
$billingPayerData['billingPostalCode'] = $billingPostcode;
}
if (!empty($billingState)) {
$billingPayerData['billingState'] = $billingState;
}
return $billingPayerData;
}

function _get_numeric_currency_code($currency_code) {
$currency_codes = array(
'BYN' => '933',
'BHD' => '048',
'BYR' => '974',
'CAD' => '124',
'CNY' => '156',
'EUR' => '978',
'GBP' => '826',
'HKD' => '344',
'HUF' => '348',
'ILS' => '376',
'JPY' => '392',
'KGS' => '417',
'KRW' => '410',
'KZT' => '398',
'MDL' => '498',
'MYR' => '458',
'OMR' => '512',
'PHP' => '608',
'RON' => '946',
'RUB' => '643',
'RUR' => '810',
'SGD' => '702',
'UAH' => '980',
'USD' => '840',
'NGN' => '566',
'MZN' => '943',
'BGN' => '975',
'BZD' => '084',
'GHS' => '936',
'GNF' => '324',
'XOF' => '952',
'PLN' => '985',
'LSL' => '426',
'TZS' => '834',
'NZD' => '554',
'KHR' => '116',
'TRY' => '949',
'AMD' => '051',
'SAR' => '682',
'AED' => '784',
'COP' => '170',
'AUD' => '036',
'IDR' => '360',
'KWD' => '414',
'JOD' => '400',
'INR' => '356'
);
return isset($currency_codes[$currency_code]) ? $currency_codes[$currency_code] : null;
}
}