<?php
defined('_JEXEC') or die();
require_once(__DIR__ . '/include.php');
$bpc_default_merchant_token = '';
$merchant = isset($params['bpc_merchant_login']) ? $params['bpc_merchant_login'] : "";
$password = isset($params['bpc_merchant_password']) ? $params['bpc_merchant_password'] : "";
if (!empty($merchant) && !empty($password)) {
$bpc_default_merchant_token = base64_encode($merchant . ":" . $password);
}
?>
<div class="col100">
<fieldset class="adminform">
<table class="admintable">
<tr>
<td colspan="2">
<h3><?php echo _JSHOP_BPC_SETTINGS_HEADER1; ?></h3>
</td>
</tr>
<?php if (defined('BPC_API_VERSION') && BPC_API_VERSION >= 2) : ?>
<tr>
<td class="key" >
<?php echo _JSHOP_BPC_TOKEN_LABEL; ?>
</td>
<td>
<input type="password" name="pm_params[bpc_merchant_token]" class="inputbox form-control"
value="<?= !empty($params['bpc_merchant_token']) ? $params['bpc_merchant_token'] : $bpc_default_merchant_token ?>">
</td>
</tr>
<?php else :?>
<tr>
<td class="key" >
<?php echo _JSHOP_BPC_LOGIN_LABEL; ?>
</td>
<td>
<input type="text" name="pm_params[bpc_merchant_login]" class="inputbox form-control"
value="<?= isset($params['bpc_merchant_login']) ? $params['bpc_merchant_login'] : "" ?>">
</td>
</tr>
<tr>
<td class="key">
<?php echo _JSHOP_BPC_PASSWORD_LABEL; ?>
</td>
<td>
<input type="password" name="pm_params[bpc_merchant_password]" class="inputbox form-control"
value="<?= isset($params['bpc_merchant_password']) ? $params['bpc_merchant_password'] : "" ?>">
</td>
</tr>
<?php endif ?>
<tr>
<td style="width:300px;" class="key">
<?php echo _JSHOP_BPC_TEST_MODE_LABEL; ?>
</td>
<td>
<?php
print JHTML::_('select.booleanlist', 'pm_params[bpc_test_mode]', 'class = "inputbox" size = "1"', $params['bpc_test_mode']);
?>
</td>
</tr>
<tr>
<td style="width:250px;" class="key">
<?php echo _JSHOP_BPC_PHASE_LABEL; ?>
</td>
<td>
<?php
print JHTML::_('select.booleanlist', 'pm_params[bpc_two_stage]', 'class = "inputbox" size = "1"', $params['bpc_two_stage']);
?>
</td>
</tr>
<?php if (file_exists(dirname(__FILE__) . "/cacert.cer")) {?>
<tr>
<td style="width:300px;" class="key">
<?php echo _JSHOP_BPC_VERIFY_SSL_CERTIFICATE_LABEL; ?>
</td>
<td>
<?php
print JHTML::_('select.booleanlist', 'pm_params[bpc_enable_cacert]', 'class = "inputbox" size = "1"', $params['bpc_enable_cacert']);
?>
</td>
</tr>
<?php }?>
<tr>
<td colspan="2">
<h3><?php echo _JSHOP_BPC_SETTINGS_HEADER2; ?></h3>
</td>
</tr>
<tr>
<td class="key">
<?php echo _JSHOP_BPC_PAYMENT_STATE_SUCCESSFUL; ?>
</td>
<td>
<?php print JHTML::_('select.genericlist', $orders->getAllOrderStatus(), 'pm_params[transaction_end_status]', 'class = "inputbox form-control form-select" ', 'status_id', 'name', $params['transaction_end_status']); ?>
</td>
</tr>
<tr>
<td class="key">
<?php echo _JSHOP_BPC_PAYMENT_STATE_FAILED; ?>
</td>
<td>
<?php echo JHTML::_('select.genericlist', $orders->getAllOrderStatus(), 'pm_params[transaction_failed_status]', 'class = "inputbox form-control form-select" ', 'status_id', 'name', $params['transaction_failed_status']); ?>
</td>
</tr>
<?php if (defined('BPC_ENABLE_BACK_URL_SETTINGS') && BPC_ENABLE_BACK_URL_SETTINGS === true) : ?>
<tr>
<td class="key" >
<?php echo _JSHOP_BPC_BACK_URL_LABEL; ?>
</td>
<td>
<input type="text" name="pm_params[bpc_back_url]" class="inputbox form-control"
value="<?= isset($params['bpc_back_url']) ? $params['bpc_back_url'] : "" ?>">
</td>
</tr>
<?php endif; ?>
<?php if (defined('BPC_ENABLE_CART_OPTIONS') && BPC_ENABLE_CART_OPTIONS === true) : ?>
<tr>
<td class="key">
<?php echo _JSHOP_BPC_SEND_ORDER_LABEL; ?>
</td>
<td>
<?php
print JHTML::_('select.booleanlist', 'pm_params[bpc_send_cart_data]', 'class = "inputbox" size = "1"', $params['bpc_send_cart_data']);
?>
</td>
</tr>
<tr>
<td class="key">
<?php echo _JSHOP_BPC_TAX_SYSTEM_LABEL; ?>
</td>
<td>
<?php echo JHTML::_('select.genericlist', $bpc_taxSystems, 'pm_params[bpc_taxSystem]', 'class = "inputbox form-control form-select"', 'id', 'name', $params['bpc_taxSystem']); ?>
</td>
</tr>
<tr>
<td class="key">
<?php echo _JSHOP_BPC_FFD_VERSION_LABEL; ?>
</td>
<td>
<?php echo JHTML::_('select.genericlist', $bpc_ffdVersions, 'pm_params[bpc_version]', 'class = "inputbox form-control form-select"', 'id', 'name', $params['bpc_version']); ?>
</td>
</tr>
<tr>
<td class="key">
<?php echo _JSHOP_BPC_PAYMENT_METHOD_LABEL; ?>
</td>
<td>
<?php echo JHTML::_('select.genericlist', $bpc_paymentMethodTypeList, 'pm_params[bpc_paymentMethodType]', 'class = "inputbox form-control form-select"', 'id', 'name', $params['bpc_paymentMethodType']); ?>
</td>
</tr>
<tr>
<td class="key">
<?php echo _JSHOP_BPC_PAYMENT_OBJECT_LABEL; ?>
</td>
<td>
<?php echo JHTML::_('select.genericlist', $bpc_paymentObjectTypeList, 'pm_params[bpc_paymentObjectType]', 'class = "inputbox form-control form-select"', 'id', 'name', $params['bpc_paymentObjectType']); ?>
</td>
</tr>
<?php endif; ?>
</table>
</fieldset>
</div>
<div class="clr"></div>